; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    unstring        PROTO :DWORD,:DWORD,:DWORD

    .data
      rec1          db "66583;0000084000028;TESTER-2;TESTER-2;Herr;SAARBRUECKEN;XYZ;1;0681/1000;D"
      rec2          db "66583;0000084000028;|TESTER-2;TESTER-2|;|Herr|;|SAARBRUECKEN|;|XYZ|;1;0681/1000;|D|"
      SingleField   db 200 dup (0)
      Separator     db ";", 0,0,0
      Delimiter     db "|", 0,0,0
      Table         dd 200 dup (0)
      Pos           dd ?
      Len           dd ?
      I             dd ?         


    .code

start:
   
; 

    call main
    inkey
    exit

; 

main proc

    print "Testing Unstring",13,10

; show original record 
    invoke RtlZeroMemory, addr SingleField, sizeof SingleField  ; clear field 
    invoke MemCopy, addr rec1, addr SingleField, sizeof rec1
    print chr$("Rec 1 : ")
    print addr SingleField, 13, 10

    invoke unstring, addr rec1, addr Separator, addr Delimiter, addr Table, sizeof rec1 
    mov I, eax

; display each single item
    print str$(eax)," single fields",13,10, 13, 10
    lea esi, Table
    xor ecx, ecx
@@:
       lea edx, rec1
       add edx, [esi+ecx*8]                                        ; position of single item
       sub edx, 1
       mov Pos, edx                                                
       mov eax, [esi+ecx*8+4]                                      ; length of single item
       mov Len, eax
       push ecx
       invoke RtlZeroMemory, addr SingleField, sizeof SingleField  ; clear field 
       invoke MemCopy, Pos, addr SingleField, Len
       print addr SingleField, 13, 10
       pop ecx
       add ecx, 1
    .if ecx < I
       jmp @B
    .endif

    print " " ,13, 10, 13, 10


    invoke RtlZeroMemory, addr SingleField, sizeof SingleField  ; clear field 
    invoke MemCopy, addr rec2, addr SingleField, sizeof rec2
    print chr$("Rec 2 : ")
    print addr SingleField, 13, 10

    invoke unstring, addr rec2, addr Separator, addr Delimiter, addr Table, sizeof rec2
    mov I, eax
    print str$(eax)," single fields",13,10, 13, 10
    lea esi, Table
    .while I > 0 
       lea edx, rec2
       add edx, [esi]
       sub edx, 1
       mov Pos, edx                                                ; position of single item
       mov eax, [esi + 4]                                          ; length of single item
       mov Len, eax
       
       invoke RtlZeroMemory, addr SingleField, sizeof SingleField  ; clear field 
       invoke MemCopy, Pos, addr SingleField, Len
       print addr SingleField, 13, 10

       add esi, 8
       sub I, 1
    .endw


    ret

main endp

; 



;****************************************************************************************
unstring proc uses ebx ecx edx edi esi , 
           pText:dword,
           pSeparator:dword,           
           pDelimiter:dword,
           pTable:dword,
           LenString:dword           
;****************************************************************************************
  Local Fields:DWORD
  xor eax, eax
  mov ecx, LenString
  
  .if ecx == 0
        ret
  .endif
  
  xor ebx, ebx
  mov esi, pSeparator
  mov bl, [esi]

  mov esi, pDelimiter
  mov bh, [esi]
   
  mov esi, pText  
  mov edi, pTable

  mov [edi + 4], eax                         
  mov edx, eax                              
  add eax, 1
  mov Fields, eax
  mov [edi], eax                            ; startposition 1st item

  cld

  add edi, 4                                ; Um Displacement im Normalfall zu vermeiden

  .if bh == 20h                             ; no delimiter 

@@:
    .if ecx <= 0
      jmp Ende
    .endif

    lodsb                                     
    dec ecx
  
    .if al == bl
        add Fields, 1                          ; new item
        mov eax, esi                           ; actual relative position
        xor edx, edx
        sub eax, pText
        add edi, 8                             
        add eax, 1

        mov dword PTR[edi - 4], eax            ; new position
        mov dword PTR[edi], edx                ; new length = 0
    .else
        add dword PTR[edi], 1                  ; length + 1
    .endif

     jmp @B   

  .else

@@:

    .if ecx <= 0
      jmp Ende
    .endif

    lodsb                                     
    sub ecx, 1
  
    .if al == bl || al == bh                       ; delimiter or separator?
        .if al == bl                               ; separator
            add Fields, 1                          ; new item
            mov eax, esi                           ; actual relative position
            xor edx, edx
            sub eax, pText
            add edi, 8                             ; next row
            add eax, 1

            mov dword PTR[edi - 4], eax            ; neue Position
            mov dword PTR[edi], edx                ; new length     
        .else

            add dword PTR[edi - 4], 1              ; new position + 1

@1:                                                ; delimiter found 
    .if ecx <= 0
      jmp Ende
    .endif

            lodsb                                  ; looking for next delimiter

            dec ecx
            .if al == bh                                               
                jmp @B             
            .else
                add dword PTR[edi], 1            
            .endif

            jmp @1

        .endif    
    .else
        add dword PTR[edi], 1
    .endif

    jmp @B   


  .endif
  
Ende:
  mov eax, Fields                              ; count of items
  ret

unstring endp

end start




















